// Criptogramas
// (C) Agosto 1.996 durante el veraneo
// Salvador Pozo Coronado
// Revisin en Junio de 2.000

#include "comun.h"
#include "sobrecri.h"
#include "recursos.h"

// Para hacer innecesaria la inclusin de este archivo y la consiguiente
// compilacin cada vez que se modifica la libreria de frases se
// define el valor de N_FRASES y TEXTO1, que son los unicos que se
// necesitan, y que adems no varan.
//#include "frases.h"
#define N_FRASES		999
#define TEXTO1			1000

#define LONG_LINEA   56
#define ENCAJA 		0
#define SELECT			1
#define DESTINO		2
#define BORRAR			3

#include "letras.h"

static TModule  ResourceFrases("frases.dll");   // DLL to be loaded.
static TModule  ResourceLetras("letras.dll");   // DLL to be loaded.

typedef struct
{
	HBITMAP 	BM;
	int 		XCaja, YCaja;
	int		Status;
	int		Dest;
	TRect		Re;
} TipoFicha;

typedef struct
{
	TRect		Re;
	char		Letra;
} TipoLetra;

typedef struct
{
	char Pal[4];
	int  Con;
} TipoPalabra;

// Dialogo de Presentacin
class TTraslacion : public TWindow {
  public:
	 TTraslacion(/*char *Tab, char *Tra, char *Buf*/);
	 ~TTraslacion();

  private:
	 HFONT 		hFont1, hFont2;
	 TWindow		*Padre;
	 char			*Tabla;
	 char 		*Traduccion;
	 char			*Texto;
	 char 		*Trabajo;
	 char       *Trabajo2;
	 WORD 		fx, fy;		  // Cambio de coordenadas
	 TipoFicha 	*Ficha;
	 TipoLetra	*Letra;
	 HBITMAP		Vacio;
	 BOOL			Status;
	 int			FichaSel;
	 HBRUSH 		Fondo;
	 HBRUSH 		Fondo2;
	 HBRUSH 		Fondo3;

  protected:
	 void EvPaint();
	 void EvLButtonUp(uint modKeys, TPoint& point);
	 void EvLButtonDown(uint modKeys, TPoint& point);
	 void EvMouseMove(uint modKeys, TPoint& point);
	 void EvLButtonDblClk(uint modKeys, TPoint& point);
	 void cmOk();
	 void cmCancel();
	 void SetupWindow();
	 void CleanupWindow();
	 void Escribe(TPaintDC *dc, int x, int y, char *cad);
	 void cmSobre();
	 void cmEstadisticas();
	 void cmNuevo();
	 void Barajar();
	 void PintaLetra(TDC& dc, HBITMAP hBM, int x, int y, int Sel);
	 void Actualiza();

  public:

  DECLARE_RESPONSE_TABLE(TTraslacion);
};

class TEstadisticas : public TDialog {
  public:
	 TEstadisticas(TWindow *Parent, char *Tab, char *Buf);
	 ~TEstadisticas();

  private:
	 TWindow		   *Padre;
    TTreeWindow   *Arbol;
//    TImageList*  Imagenes;

	 char				*Tabla;
	 char				*Texto;
	 int        	Cuenta[27];
	 int 				NPalabras1;
	 TipoPalabra	*Palabra1;
	 int 				NPalabras2;
	 TipoPalabra	*Palabra2;
	 int 				NPalabras3;
	 TipoPalabra	*Palabra3;
	 int				Repeticiones;
	 TipoPalabra	*Repeticion;

  protected:
	 bool EvInitDialog(HWND);
	 bool EsLetra(char a);
    void IniciaArbol();

  public:

  DECLARE_RESPONSE_TABLE(TEstadisticas);
};

DEFINE_RESPONSE_TABLE1(TTraslacion, TWindow)
	 EV_WM_PAINT,
	 EV_WM_LBUTTONUP,
	 EV_WM_LBUTTONDOWN,
	 EV_WM_MOUSEMOVE,
	 EV_WM_LBUTTONDBLCLK,
	 EV_WM_CREATE,
	 EV_COMMAND(IDOK, cmOk),
	 EV_COMMAND(IDCANCEL, cmCancel),
	 EV_COMMAND(CM_SOBRE, cmSobre),
	 EV_COMMAND(CM_ESTADISTICAS, cmEstadisticas),
	 EV_COMMAND(CM_NUEVO, cmNuevo),
END_RESPONSE_TABLE;

TTraslacion::TTraslacion(/*char *Tab, char *Tra, char *Buf*/):
	TWindow(0, 0, ::Module)
{
	Attr.X = 11;
	Attr.Y = 65;
	Attr.W = 621;
	Attr.H = 380;
	new TButton(this, IDOK, "Verificar", 550, 16, 64, 41, TRUE);
	new TButton(this, IDCANCEL, "Salir", 550, 91, 64, 41, FALSE);
	new TButton(this, CM_NUEVO, "&Nuevo", 550, 166, 64, 41, FALSE);
	new TButton(this, CM_ESTADISTICAS, "&Estads", 550, 241, 64, 41, FALSE);
	new TButton(this, CM_SOBRE, "&Sobre", 550, 315, 64, 41, FALSE);
	Padre = Parent;
	Tabla = ::new char[36];
	Traduccion = ::new char[36];
	Texto = ::new char[LONGITUD_MAX+1];
	Trabajo = ::new char[LONGITUD_MAX + 1];
	Trabajo2 = ::new char[LONGITUD_MAX + 1];
	Ficha = ::new TipoFicha[27];
	Letra = ::new TipoLetra[27];
	hFont1 = CreateFont(16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Courier New");
	hFont2 = CreateFont(20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Arial");
	Fondo  = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	Fondo2 = (HBRUSH)GetStockObject(DKGRAY_BRUSH);
	Fondo3 = (HBRUSH)GetStockObject(GRAY_BRUSH);
}

TTraslacion::~TTraslacion()
{
	::delete[] Tabla;
	::delete[] Traduccion;
	::delete[] Texto;
	::delete[] Trabajo;
	::delete[] Trabajo2;
	::delete[] Ficha;
	::delete[] Letra;
	DeleteObject(hFont1);
	DeleteObject(hFont2);
}

void TTraslacion::EvLButtonDown(uint, TPoint& point)
{
	int i;

	for(i = 0; i < 27; i++)
		if(Ficha[i].Re.Contains(point))
		{
			if(Ficha[i].Status == DESTINO)
				Letra[Ficha[i].Dest].Letra = '-'-'A';
			Ficha[i].Status = SELECT;
			Status = TRUE;
			FichaSel = i;
		}
}

void TTraslacion::EvLButtonUp(uint, TPoint& point)
{
	int i;

	if(Status)
	{
		Status = FALSE;
		// Varios casos:
		// 1) se suelta en letra libre.
		// 2) se suelta en letra ocupada.
		// 3) Se suelta en caja
		for(i = 0; i < 27; i++)
			if(Letra[i].Re.Contains(point))
				if(Letra[i].Letra == '-'-'A') // Caso 1
				{
					Ficha[FichaSel].Status = DESTINO;
					Ficha[FichaSel].Dest = i;
					Letra[i].Letra = (char)FichaSel;  // orden alfabtico normal: A....Z ->0..14..26
					Ficha[FichaSel].Re = Letra[i].Re;
					Actualiza();
					Invalidate();
					return;
				}
		// Caso 2 o 3
		Ficha[FichaSel].Status = ENCAJA;
		Ficha[FichaSel].Re.left = Ficha[FichaSel].XCaja;
		Ficha[FichaSel].Re.top = Ficha[FichaSel].YCaja;
		Ficha[FichaSel].Re.right = Ficha[FichaSel].XCaja+24;
		Ficha[FichaSel].Re.bottom = Ficha[FichaSel].YCaja+24;
		Actualiza();
		Invalidate();
	}
}

void TTraslacion::EvMouseMove(uint, TPoint& point)
{
	if(Status)
	{
		Ficha[FichaSel].Status = BORRAR;
		InvalidateRect(Ficha[FichaSel].Re);
		Ficha[FichaSel].Re.left = point.x-12;
		Ficha[FichaSel].Re.top = point.y-12;
		Ficha[FichaSel].Re.right = point.x+12;
		Ficha[FichaSel].Re.bottom = point.y+12;
		Ficha[FichaSel].Status = SELECT;
		InvalidateRect(Ficha[FichaSel].Re);
	}
}

void TTraslacion::EvLButtonDblClk(uint, TPoint& point)
{
	// Mandar letra directamente a caja
	int i;

	for(i = 0; i < 27; i++)
		if(Letra[i].Re.Contains(point))
			if(Letra[i].Letra != '-'-'A') // Caso 1
			{
				Letra[i].Letra = '-'-'A';
				Ficha[FichaSel].Status = ENCAJA;
				Ficha[FichaSel].Re.left = Ficha[FichaSel].XCaja;
				Ficha[FichaSel].Re.top = Ficha[FichaSel].YCaja;
				Ficha[FichaSel].Re.right = Ficha[FichaSel].XCaja+24;
				Ficha[FichaSel].Re.bottom = Ficha[FichaSel].YCaja+24;
				Actualiza();
				Invalidate();
			}
}

void TTraslacion::SetupWindow()
{
	int i;

	TWindow::SetupWindow();
	Status = FALSE;
	Vacio = ResourceLetras.LoadBitmap(LETRA__);
	for(i = 0; i < 14; i++)
	{
		Ficha[i].BM = ResourceLetras.LoadBitmap(LETRA_A+i);
		Ficha[i].XCaja = 480;
		Ficha[i].YCaja = 10+i*26;
	}
	for(i = 0; i < 13; i++)
	{
		Ficha[14+i].BM = ResourceLetras.LoadBitmap(LETRA_A+i+14);
		Ficha[14+i].XCaja = 508;
		Ficha[14+i].YCaja = 10+i*26;
	}
	for(i = 0; i < 9; i++)
	{
		Letra[i].Re.left   = 32+50*i;
		Letra[i].Re.top    = 286;
		Letra[i].Re.right  = Letra[i].Re.left + 24;
		Letra[i].Re.bottom = Letra[i].Re.top  + 24;
	}
	for(i = 0; i < 9; i++)
	{
		Letra[i+9].Re.left   = 32+50*i;
		Letra[i+9].Re.top    = 314;
		Letra[i+9].Re.right  = Letra[i+9].Re.left + 24;
		Letra[i+9].Re.bottom = Letra[i+9].Re.top  + 24;
	}
	for(i = 0; i < 9; i++)
	{
		Letra[i+18].Re.left   = 32+50*i;
		Letra[i+18].Re.top    = 341;
		Letra[i+18].Re.right  = Letra[i+18].Re.left + 24;
		Letra[i+18].Re.bottom = Letra[i+18].Re.top  + 24;
	}
	cmNuevo();
}

void TTraslacion::CleanupWindow()
{
	int i;

	for(i = 0; i < 27; i++)
	  if (Ficha[i].BM)
		 ::DeleteObject(Ficha[i].BM);
	if (Vacio)
		::DeleteObject(Vacio);
}

void TTraslacion::cmOk()
{
	// Verificar el texto:
	if(!strcmp(Texto, Trabajo2))
		MessageBox("El texto ha sido descifrado correctamente.",
      	"CORRECTO", MB_ICONINFORMATION | MB_OK);
	else
		MessageBox("El texto an no ha sido descifrado correctamente. "
      	"Sigue intentndolo", "INCORRECTO", MB_ICONINFORMATION | MB_OK);

}

void TTraslacion::cmCancel()
{
	Destroy(FALSE);
}

void TTraslacion::Actualiza()
{
  int i;

  for(i = 0; Texto[i]; i++)
	  if(Texto[i] >= 'A' && Texto[i] <= 'Z')
		  Trabajo[i] = Tabla[Texto[i] - 'A'];
	  else
		  if(Texto[i] == '')
			  Trabajo[i] = Tabla[26];
		  else
			  Trabajo[i] = Texto[i];
  Trabajo[i] = 0;

  for(i = 0; Trabajo[i]; i++)
  {
	  if(Trabajo[i] >= 'A' && Trabajo[i] <= 'N')
		  Trabajo2[i] = (char)('A'+Letra[Trabajo[i]-'A'].Letra); //Traduccion[Trabajo[i]-'A'];
	  else
		  if(Trabajo[i] >= 'O' && Trabajo[i] <= 'Z')
			  Trabajo2[i] = (char)('A'+Letra[Trabajo[i]-'A'+1].Letra); //Traduccion[26];
		  else
			  if(Trabajo[i] == '')
				  Trabajo2[i] = (char)('A'+Letra[14].Letra);
			  else
				  Trabajo2[i] = Trabajo[i];

	  if(Trabajo2[i] > 'O' && Trabajo2[i] <= 'Z'+1)    //??? letra despues de 'Z'
		  Trabajo2[i]--;
	  else
		  if(Trabajo2[i] == 'O') Trabajo2[i] = '';
	  }
  Trabajo2[i] = 0;
}

void TTraslacion::EvPaint()
{
  TPaintDC	dc(*this);
  int i;
  TRect re;
  char cad[2];

  GetClientRect(re);
  dc.FillRect(re, Fondo);
  re.Set(4, 5, 466, 137);
  dc.FillRect(re, Fondo3);
  re.Set(4, 138, 466, 271);
  dc.FillRect(re, Fondo3);
  re.Set(474, 5, 537, 377);
  dc.FillRect(re, Fondo3);
  re.Set(5, 276, 466, 377);
  dc.FillRect(re, Fondo3);
  re.Set(543, 1, 544, 386);
  dc.FillRect(re, Fondo2);

  re.Set(6, 7, 462, 133);
  dc.FillRect(re, Fondo);
  re.Set(6, 140, 462, 267);
  dc.FillRect(re, Fondo);
  re.Set(476, 7, 533, 373);
  dc.FillRect(re, Fondo);
  re.Set(7, 278, 462, 373);
  dc.FillRect(re, Fondo);

  dc.SetBkMode(TRANSPARENT);
  dc.SelectObject(hFont1);
  dc.SetTextColor(RGB(0, 0, 0));
  Escribe(&dc, 9, 10, Trabajo);

  dc.SetTextColor(RGB(255, 0, 0));
  Escribe(&dc, 9, 143, Trabajo2);

  dc.SelectObject(hFont2);
  cad[1] = 0;
  dc.SetTextColor(RGB(0, 0, 0));
  for(i = 0; i < 9;i++)
  {
		cad[0] = (char)('A'+i);
		dc.TextOut( 11+50*i, 288, cad, 1);
  }
  for(i = 0; i < 5;i++)
  {
		cad[0] = (char)('J'+i);
		dc.TextOut( 11+50*i, 319, cad, 1);
  }
  cad[0] = '';
  dc.TextOut( 264, 319, cad, 1);
  for(i = 6; i < 9;i++)
  {
		cad[0] = (char)('I'+i);
		dc.TextOut( 11+50*i, 319, cad, 1);
  }
  for(i = 0; i < 9;i++)
  {
		cad[0] = (char)('R'+i);
		dc.TextOut( 11+50*i, 349, cad, 1);
  }

  for(i = 0; i < 27; i++)
	  if(Letra[i].Letra == '-'-'A')
		  PintaLetra(dc, Vacio, Letra[i].Re.left, Letra[i].Re.top, DESTINO);

  for(i = 0; i < 27; i++)
	  PintaLetra(dc, Ficha[i].BM, Ficha[i].Re.left,
			Ficha[i].Re.top, Ficha[i].Status);
  if(Status)
	  PintaLetra(dc, Ficha[FichaSel].BM, Ficha[FichaSel].Re.left,
			Ficha[FichaSel].Re.top, Ficha[FichaSel].Status);
}

void TTraslacion::PintaLetra(TDC& dc, HBITMAP hBM, int x, int y, int Sel)
{
  if(hBM)
  {
		TMemoryDC memDC;
		memDC.SelectObject(TBitmap(hBM));
		if(Sel != BORRAR)
			dc.BitBlt(x, y, 24, 24, memDC, 0, 0);
  }
}

void TTraslacion::Escribe(TPaintDC *dc, int x, int y, char *cad)
{
  char *Linea;
  int i;

  Linea = cad;
  for(i = 0; i < strlen(cad)/LONG_LINEA; i++)
	  dc->TextOut( x, y+i*12, &Linea[i*LONG_LINEA], LONG_LINEA);
  dc->TextOut( x, y+i*12, &Linea[i*LONG_LINEA], strlen(&Linea[i*LONG_LINEA]));
}

void TTraslacion::cmSobre()
{
	TSobre(this, false).Execute();
}

void TTraslacion::cmEstadisticas()
{
	TEstadisticas(this, Tabla, Texto).Execute();
}

void TTraslacion::cmNuevo()
{
	int i;

	Barajar();

	for(i = 0; i < 27; i++)
	{
		Ficha[i].Status = ENCAJA;
		Ficha[i].Re.left   = Ficha[i].XCaja;
		Ficha[i].Re.top    = Ficha[i].YCaja;
		Ficha[i].Re.right  = Ficha[i].XCaja + 24;
		Ficha[i].Re.bottom = Ficha[i].YCaja + 24;
		Letra[i].Letra     = '-'-'A';
	}
	Actualiza();
	Invalidate();
}

void TTraslacion::Barajar()
{
	int i, j, NFrases;
	char a;
	char N_Frases[6];

	ResourceFrases.LoadString(N_FRASES, N_Frases, 6);
	NFrases = atoi(N_Frases);

	i = TEXTO1 + random(NFrases);
	ResourceFrases.LoadString(i, Texto, LONGITUD_MAX);
	ResourceFrases.LoadString(i+2000, Trabajo, LONGITUD_MAX);
	strcat(Texto, Trabajo);
	for(i = 0; i < strlen(Texto); i++)
		if(Texto[i] == '')
			Texto[i] = '';
		else
			Texto[i] = (char)toupper(Texto[i]);
	for(i = 0; i < 26; i++) Tabla[i] = (char)(i + 'A');
	Tabla[26] = '';
	// Aadir los nmeros y los signos de puntuacin.
	// Barajar:
	for(i = 0; i < 27; i++)
	{
		j = i + random(27-i);
		a = Tabla[j];
		Tabla[j] = Tabla[i];
		Tabla[i] = a;
	}
	Actualiza();
}

// Dialogo de Estadsticas

DEFINE_RESPONSE_TABLE1(TEstadisticas, TDialog)
END_RESPONSE_TABLE;

TEstadisticas::TEstadisticas(TWindow *Parent, char *Tab, char *Buf):
	TDialog(Parent, DlgEstadisticas)
{
	Padre = Parent;
	Tabla = Tab;
	Texto = Buf;

   Arbol = new TTreeWindow(this, STAT_ARBOL);

   Palabra1 = ::new TipoPalabra[40];
   Palabra2 = ::new TipoPalabra[40];
   Palabra3 = ::new TipoPalabra[40];
   Repeticion = ::new TipoPalabra[6];
}
TEstadisticas::~TEstadisticas()
{
	::delete[] Palabra1;
	::delete[] Palabra2;
	::delete[] Palabra3;
	::delete[] Repeticion;
   delete Arbol;
}

bool TEstadisticas::EvInitDialog(HWND)
{
	int i, j;

	// Cuenta letras
	TDialog::SetupWindow();

	for(i = 0; i < 27; i++) Cuenta[i] = 0;
	for(i = 0; i < strlen(Texto); i++)
		if(EsLetra(Texto[i]))
      	// La letra '' es un caso especial, ya que no mantiene el orden alfabtico
         // en el formato ASCII
			if(Tabla[Texto[i]-'A'] != '')
				Cuenta[Tabla[Texto[i]-'A']-'A']++;
			else
				Cuenta[26]++;

	// Cuenta palabras de una letra:
	NPalabras1 = 0;
	i = 0;
	while(Texto[i])
	{
		if(EsLetra(Texto[i]) && !EsLetra(Texto[i+1]))
		{
			// Busca anterior coincidencia:
			for(j = 0; j < NPalabras1; j++)
				if(Palabra1[j].Pal[0] == Tabla[Texto[i]-'A']) break;

			if(j == NPalabras1)  // Nueva
			{
				Palabra1[NPalabras1].Pal[0] = Tabla[Texto[i]-'A'];
				Palabra1[NPalabras1].Pal[1] = 0;
				Palabra1[NPalabras1].Con = 1;
				NPalabras1++;
			}
			else                 // Repeticin
				Palabra1[j].Con++;
		}
		while(EsLetra(Texto[i])) i++;
		if(Texto[i]) i++;
	}

	// Cuenta palabras de dos letras:
	NPalabras2 = 0;
	i = 0;
	while(Texto[i])
	{
		if(EsLetra(Texto[i]) && EsLetra(Texto[i+1]) && !EsLetra(Texto[i+2]))
		{
			// Busca anterior coincidencia:
			for(j = 0; j < NPalabras2; j++)
				if(Palabra2[j].Pal[0] == Tabla[Texto[i]-'A'] &&
					Palabra2[j].Pal[1] == Tabla[Texto[i+1]-'A']) break;

			if(j == NPalabras2)  // Nueva
			{
				Palabra2[NPalabras2].Pal[0] = Tabla[Texto[i]-'A'];
				Palabra2[NPalabras2].Pal[1] = Tabla[Texto[i+1]-'A'];
				Palabra2[NPalabras2].Pal[2] = 0;
				Palabra2[NPalabras2].Con = 1;
				NPalabras2++;
			}
			else                 // Repeticin
				Palabra2[j].Con++;
		}
		while(EsLetra(Texto[i])) i++;
		if(Texto[i]) i++;
	}

	// Cuenta palabras de tres letras:
	NPalabras3 = 0;
	i = 0;
	while(Texto[i])
	{
		if(EsLetra(Texto[i]) && EsLetra(Texto[i+1]) && EsLetra(Texto[i+2]) && !EsLetra(Texto[i+3]))
		{
			// Busca anterior coincidencia:
			for(j = 0; j < NPalabras3; j++)
				if(Palabra3[j].Pal[0] == Tabla[Texto[i]-'A'] &&
					Palabra3[j].Pal[1] == Tabla[Texto[i+1]-'A'] &&
					Palabra3[j].Pal[2] == Tabla[Texto[i+2]-'A']) break;

			if(j == NPalabras3)  // Nueva
			{
				Palabra3[NPalabras3].Pal[0] = Tabla[Texto[i]-'A'];
				Palabra3[NPalabras3].Pal[1] = Tabla[Texto[i+1]-'A'];
				Palabra3[NPalabras3].Pal[2] = Tabla[Texto[i+2]-'A'];
				Palabra3[NPalabras3].Pal[3] = 0;
				Palabra3[NPalabras3].Con = 1;
				NPalabras3++;
			}
			else                 // Repeticin
				Palabra3[j].Con++;
		}
		while(EsLetra(Texto[i])) i++;
		if(Texto[i]) i++;
	}

	Repeticiones = 0;
	i = 0;
	while(Texto[i])
	{
		if(EsLetra(Texto[i]) && Texto[i] == Texto[i+1])
		{
			// Busca anterior coincidencia:
			for(j = 0; j < Repeticiones; j++)
				if(Repeticion[j].Pal[0] == Tabla[Texto[i]-'A']) break;

			if(j == Repeticiones)  // Nueva
			{
				Repeticion[Repeticiones].Pal[0] = Tabla[Texto[i]-'A'];
				Repeticion[Repeticiones].Pal[1] = 0;
				Repeticion[Repeticiones].Con = 1;
				Repeticiones++;
			}
			else                 // Repeticin
				Repeticion[j].Con++;
		}
		i++;
	}

//	Inicia arbol:
	IniciaArbol();
	return true;
}

bool TEstadisticas::EsLetra(char a)
{
	return (a >= 'A' && a <= 'Z') || a == '';
}

void TEstadisticas::IniciaArbol()
{
   TTreeItem Item;
   char cad[80], pat1[40], pat2[40];
	int i;

	Arbol->DeleteAllItems();
   TTreeNode root = Arbol->GetRoot();
   TTreeNode nodo(root);

	GetApplication()->LoadString(STAT_L1, cad, 79);
	Item.SetText(cad);
//	Item.SetImageIndex(0);
//	Item.SetSelectedImageIndex(1);
  	nodo = root.AddChild(Item);
	for(i = 0; i < 27; i++)
	   if(Cuenta[i])
		{
			if(i < 26)
				sprintf(cad, "%c - %2d", i+'A', Cuenta[i]);
			else
				sprintf(cad, " - %2d", Cuenta[i]);
			Item.SetText(cad);
//			Item.SetImageIndex(3);
//			Item.SetSelectedImageIndex(2);
			nodo.AddChild(Item);
		}

	GetApplication()->LoadString(STAT_L1+5, cad, 39);
	GetApplication()->LoadString(STAT_L1+3, pat1, 39);
	GetApplication()->LoadString(STAT_L1+4, pat2, 39);
	Item.SetText(cad);
//   Item.SetImageIndex(0);
//	Item.SetSelectedImageIndex(1);
  	nodo = root.AddChild(Item);
	for(i = 0; i < NPalabras1; i++)
	{
		if(Palabra1[i].Con == 1) sprintf(cad, pat2, Palabra1[i].Pal);
      else sprintf(cad, pat1, Palabra1[i].Pal, Palabra1[i].Con);
		Item.SetText(cad);
//		Item.SetImageIndex(3);
//		Item.SetSelectedImageIndex(2);
		nodo.AddChild(Item);
	}

	GetApplication()->LoadString(STAT_L1+1, cad, 39);
	Item.SetText(cad);
//   Item.SetImageIndex(0);
//	Item.SetSelectedImageIndex(1);
  	nodo = root.AddChild(Item);
	for(i = 0; i < NPalabras2; i++)
	{
		if(Palabra2[i].Con == 1) sprintf(cad, pat2, Palabra2[i].Pal);
      else sprintf(cad, pat1, Palabra2[i].Pal, Palabra2[i].Con);
		Item.SetText(cad);
//		Item.SetImageIndex(3);
//		Item.SetSelectedImageIndex(2);
		nodo.AddChild(Item);
	}

	GetApplication()->LoadString(STAT_L1+2, cad, 39);
	Item.SetText(cad);
//   Item.SetImageIndex(0);
//	Item.SetSelectedImageIndex(1);
  	nodo = root.AddChild(Item);
	for(i = 0; i < NPalabras3; i++)
	{
		if(Palabra3[i].Con == 1) sprintf(cad, pat2, Palabra3[i].Pal);
      else sprintf(cad, pat1, Palabra3[i].Pal, Palabra3[i].Con);
		Item.SetText(cad);
//		Item.SetImageIndex(3);
//		Item.SetSelectedImageIndex(2);
		nodo.AddChild(Item);
	}

	GetApplication()->LoadString(STAT_L1+6, cad, 39);
	Item.SetText(cad);
//   Item.SetImageIndex(0);
//	Item.SetSelectedImageIndex(1);
  	nodo = root.AddChild(Item);
	for(i = 0; i < Repeticiones; i++)
	{
		if(Repeticion[i].Con == 1) sprintf(cad, pat2, Repeticion[i].Pal);
      else sprintf(cad, pat1, Repeticion[i].Pal, Repeticion[i].Con);
		Item.SetText(cad);
//		Item.SetImageIndex(3);
//		Item.SetSelectedImageIndex(2);
		nodo.AddChild(Item);
	}
}

// OWL Aplicacin:
class TMyApp : public TApplication {

  public:

  protected:
	 void InitMainWindow();
};

void TMyApp::InitMainWindow()
{
  char		 Titulo[20];

  // Construct the decorated frame window
  LoadString(TITULO, Titulo, 20);

  MainWindow = new TFrameWindow(0, Titulo, new TTraslacion(), TRUE);
  MainWindow->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
  MainWindow->SetIcon(this, Cripto);
  MainWindow->SetIconSm(this, Cripto);

  randomize();
}

int OwlMain(int /*argc*/, char* /*argv*/ [])
{
	return TMyApp().Run();
}

